VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.UserControl MsgBar 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BackStyle       =   0  'Transparent
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4830
   EditAtDesignTime=   -1  'True
   Enabled         =   0   'False
   ScaleHeight     =   375
   ScaleWidth      =   4830
   Begin MSComctlLib.ImageList ilIcons 
      Left            =   840
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   12
      ImageHeight     =   12
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "MsgBar.ctx":0000
            Key             =   "error"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "MsgBar.ctx":0067
            Key             =   "info"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "MsgBar.ctx":00CF
            Key             =   "warning"
         EndProperty
      EndProperty
   End
   Begin VB.PictureBox pctFontMetrics 
      AutoRedraw      =   -1  'True
      Height          =   135
      Left            =   120
      ScaleHeight     =   135
      ScaleWidth      =   15
      TabIndex        =   1
      Top             =   240
      Visible         =   0   'False
      Width           =   15
   End
   Begin VB.TextBox txtMsg 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   0
      Width           =   4335
   End
   Begin VB.Image imgIcon 
      Height          =   255
      Left            =   45
      Top             =   45
      Width           =   255
   End
   Begin VB.Shape shpBkgd 
      BackStyle       =   1  'Opaque
      BorderColor     =   &H00008080&
      FillColor       =   &H00C0FFFF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   0
      Top             =   0
      Width           =   4815
   End
End
Attribute VB_Name = "MsgBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private Const kMinimumInterval As Integer = 5000
Private Const kDefaultMaximumLines As Integer = -1
Private Const kDefaultAnimate As Boolean = True
Private Const kDefaultBkgdColor As Long = &HC0FFFF
Private Const kDefaultMessage As String = ""

Private Declare Function SendMessage Lib "USER32" _
   Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function LockWindowUpdate Lib _
"USER32" (ByVal hwndLock As Long) As Long
Private Const EM_GETLINECOUNT = &HBA

Private msMessage As String
Private meMsgType As enmILabInfoBarMsgTypes
Private mlBkgdColor As OLE_COLOR
Private miNumLines As Integer
Private mbAnimate As Boolean
Private mnMaximumLines As Integer
Private mnPreviousMaxLines As Integer

Dim bResizing As Boolean

Enum enmILabInfoBarMsgTypes
  ibError
  ibWarning
  ibInfo
End Enum

Public Property Get BkgdColor() As OLE_COLOR
Attribute BkgdColor.VB_Description = "The background color of the info bar."
  BkgdColor = mlBkgdColor
End Property

Public Property Let BkgdColor(ByVal LonValue As OLE_COLOR)
  mlBkgdColor = LonValue
  shpBkgd.FillColor = mlBkgdColor
  txtMsg.BackColor = mlBkgdColor
  PropertyChanged "BkgdColor"
End Property

Public Property Get Message() As String
Attribute Message.VB_Description = "The message to display to the user."
  Message = msMessage
End Property

Public Property Let Message(ByVal StrValue As String)
  Dim iTxtHeight As Integer
  
  If (msMessage <> StrValue) Or (mnMaximumLines <> mnPreviousMaxLines) Then
    'set the message
    msMessage = StrValue
    txtMsg = msMessage
  
    'render text and resize control
    If mnMaximumLines < 1 Then
      RefreshSize
    Else
      FitToTextControl StrValue
    End If
    
    mnPreviousMaxLines = mnMaximumLines
    PropertyChanged "Message"
  End If
End Property

Public Property Get MessageSet() As Boolean
  MessageSet = (msMessage <> "")
End Property

'**---------------------------------------------------------------------------------------
' Get the Animate property
' True means that error messages will fade in and out
' False means that error messages will not fade in and out
' Info and warning messages do not animate no matter how this property is set.
' The default value is True, meaning animate error messages.
'
' @param  none
' @author Mike Araya
' @return Boolean - If True, error messages will fade in and out.
' @rem
Public Property Get Animate() As Boolean
  Animate = mbAnimate
End Property

'**---------------------------------------------------------------------------------------
' Set the Animate property
' True means that the message will fade in and out
' False means that the message will not fade in and out
' Info and warning messages do not animate no matter how this property is set.
' The default value is True, meaning animate error messages.
'
' @param bAnimate (Boolean) - Set it to True to make error messages fade in and out
' @author Mike Araya
' @return nothing
' @rem
Public Property Let Animate(ByVal bAnimate As Boolean)
  mbAnimate = bAnimate
  PropertyChanged "Animate"
End Property

'**---------------------------------------------------------------------------------------
' Get the MaximumLines property.
' This is the maximum number of lines that may be displayed by this control.
'
' @param  none
' @author Mike Araya
' @return Integer - the maximum number of lines displayed by this control
' @rem
Public Property Get MaximumLines() As Integer
  MaximumLines = mnMaximumLines
End Property

'**---------------------------------------------------------------------------------------
' Set the MaximumLines property.
' This property specifies the maximum number of lines that this control may display.
' Any value less than 1 is ignored and will allow this control to display an arbitrary
' number of lines.
' If the message length exceeds the maximum number of lines, the message will be truncated,
' and an ellipsis will be added to the end of the message.
'
' @param nMaximumLines (Integer) - Set this to the maximum number of lines that this
'          control may display.  Any value less than 1 is ignored and will allow this
'          control to display an arbitrary number of lines.
' @author Mike Araya
' @return nothing
' @rem
Public Property Let MaximumLines(ByVal nMaximumLines As Integer)
  mnMaximumLines = nMaximumLines
  PropertyChanged "MaximumLines"
End Property

'**---------------------------------------------------------------------------------------
' Initialization performed upon instantiation or creation at run-time.
'
' @param  none
' @author Mike Araya
' @return nothing
' @rem
Private Sub UserControl_Initialize()
  'Message = txtMsg.Text
  'txtMsg.BackColor = shpBkgd.FillColor
  'set the default color
  shpBkgd.FillColor = kDefaultBkgdColor
  txtMsg.BackColor = kDefaultBkgdColor
  
  'Set the default Animate property to True
  mbAnimate = True
  
  'Set a default message type
  meMsgType = -1
  
  'Set the maximum number of lines to -1, indicating that this control has variable height
  mnMaximumLines = -1
  mnPreviousMaxLines = -1
End Sub

Private Sub FadeOutInMessage(iTimes As Integer, _
                            iDelay As Integer)
  '<EhHeader>
  On Error GoTo FadeOutInMessage_Err
  '</EhHeader>
  Dim h As Double
  Dim s As Double
  Dim b As Double
  Dim j As Integer
  RGBtoHSB shpBkgd.FillColor, h, s, b

  For j = 1 To iTimes
    For i = 0 To 100 Step 5
      LockWindowUpdate hwnd
      txtMsg.ForeColor = HSBtoRGB(h, s, CDbl(i / 100))
      Sleep (iDelay)
      LockWindowUpdate False
      txtMsg.Refresh

    Next

    For i = 100 To 0 Step -5
      LockWindowUpdate hwnd
      txtMsg.ForeColor = HSBtoRGB(h, s, CDbl(i / 100))
    
      Sleep (iDelay)
      LockWindowUpdate False
      txtMsg.Refresh

    Next
  Next

  '<EhFooter>
  Exit Sub

FadeOutInMessage_Err:

  Select Case Err.Number

    Case Else
      Err.Raise Err.Number, Err.Source & " ctlInfoBar:FadeOutInMessage", Err.Description
  End Select

  '</EhFooter>
End Sub
Public Sub SetMessage(sMsg As String, enmMsgType As enmILabInfoBarMsgTypes)

  '<EhHeader>
  On Error GoTo SetMessage_Err
  '</EhHeader>
  Dim i As Integer
  Dim h As Double
  Dim s As Double
  Dim b As Double
  
  If sMsg = "" Then
    Err.Raise eh.AppArgumentNullError, "", "sMsg argument is required"
  End If
  
  If (sMsg <> msMessage) Or (enmMsgType <> meMsgType) Or (mnMaximumLines <> mnPreviousMaxLines) Then
    Message = sMsg
      meMsgType = enmMsgType

    Select Case (enmMsgType)
      Case enmILabInfoBarMsgTypes.ibInfo
        imgIcon.Picture = ilIcons.ListImages("info").Picture
      Case enmILabInfoBarMsgTypes.ibWarning
        imgIcon.Picture = ilIcons.ListImages("warning").Picture
      Case enmILabInfoBarMsgTypes.ibError
        imgIcon.Picture = ilIcons.ListImages("error").Picture
        Refresh
        DoEvents
        If mbAnimate Then
          FadeOutInMessage 2, 11
        End If
    End Select
  End If
  
  '<EhFooter>
  Exit Sub

SetMessage_Err:
  Select Case Err.Number
    Case Else
      Err.Raise Err.Number, Err.Source & " MsgBar:SetMessage", Err.Description
  End Select
  '</EhFooter>
End Sub

Public Sub ClearMessage()
  Message = ""
  Set imgIcon.Picture = Nothing
End Sub

'**---------------------------------------------------------------------------------------
' Returns the maximum height of this control in Twips.
' If this control does not have a maximum number of lines, this returns -1 to indicate
' that the height of the control is arbitrary and depends upon the length of the message.
'
' @param  none
' @author Mike Araya
' @return Integer - the maximum height of this control in Twips
' @rem
Public Function GetMaximumHeight() As Integer
  Dim nLineHt As Integer
  
  On Error Resume Next
  GetMaximumHeight = -1
  
  If mnMaximumLines > 0 Then
    pctFontMetrics.Font = txtMsg.Font
    pctFontMetrics.FontSize = txtMsg.FontSize
    nLineHt = pctFontMetrics.TextHeight("Xy") + 25
    GetMaximumHeight = nLineHt * mnMaximumLines
    If mnMaximumLines = 1 Then
      GetMaximumHeight = (nLineHt * mnMaximumLines) + 30
    End If
  End If
End Function

Private Sub RefreshSize()
  On Local Error Resume Next
  bResizing = True
 'get/show the number of lines in the edit control
  miNumLines = SendMessage(txtMsg.hwnd, EM_GETLINECOUNT, 0&, ByVal 0&)
  pctFontMetrics.Font = txtMsg.Font
  pctFontMetrics.FontSize = txtMsg.FontSize
  iTxtHeight = pctFontMetrics.TextHeight("Xy") + 25
'  Height = lLineCount * txtMsg.Font.Size * 26 + (lLineCount - 1) * 1

  Height = miNumLines * iTxtHeight
  If (miNumLines = 1) Then Height = Height + 30
  bResizing = False
End Sub

Public Sub FitToTextControl(ByVal sMsg As String)
  Dim nNumLines As Integer
  Dim nLineHt As Integer
  Dim nTxtHt As Integer
  Dim sOldMsg As String
  Dim bDone As Boolean
  Dim sCandidate As String
  Dim nCandidateLen As Integer
  Dim nMaxHeight As Integer
  
  On Error GoTo FitToTextControl_Err
  
  'store old message
  sOldMsg = txtMsg.Text
  
  'get max height
  nMaxHeight = GetMaximumHeight
  
  'set the new message
  txtMsg.Text = sMsg
  
  'calculate number of lines required
  nNumLines = SendMessage(txtMsg.hwnd, EM_GETLINECOUNT, 0&, ByVal 0&)
  pctFontMetrics.Font = txtMsg.Font
  pctFontMetrics.FontSize = txtMsg.FontSize
  nLineHt = pctFontMetrics.TextHeight("Xy") + 25
  nTxtHt = nLineHt * nNumLines
  
  'is the message too big?
  If (nTxtHt > nMaxHeight) Then
    'find the correct message length
    nCandidateLen = Len(sMsg)
    Do While Not bDone
      sCandidate = Left(sMsg, nCandidateLen) & "..."
      
      txtMsg.Text = sCandidate
      nNumLines = SendMessage(txtMsg.hwnd, EM_GETLINECOUNT, 0&, ByVal 0&)
      nLineHt = pctFontMetrics.TextHeight("Xy") + 25
      nTxtHt = nLineHt * nNumLines
      If (nTxtHt <= nMaxHeight) Or (nCandidateLen = 0) Then
        bDone = True
      Else
        nCandidateLen = nCandidateLen - 1
      End If
    Loop
    
    'set the message
    If nCandidateLen > 0 Then
      txtMsg.Text = sCandidate
    End If
  End If
  
  'resize the control
  Height = nNumLines * nLineHt
  If (nNumLines = 1) Then Height = Height + 30
  
  Exit Sub

FitToTextControl_Err:
  'we don't want to raise any errors here
  'Err.Raise Err.Number, Err.Source, Err.Description
End Sub

'**---------------------------------------------------------------------------------------
' Design-time property initialization - occurs when the control is placed in its container
'
' @param  none
' @author Mike Araya
' @return nothing
' @rem

Private Sub UserControl_InitProperties()
  Animate = kDefaultAnimate
  MaximumLines = kDefaultMaximumLines
  BkgdColor = kDefaultBkgdColor
  Message = kDefaultMessage
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Animate = PropBag.ReadProperty("Animate", kDefaultAnimate)
  MaximumLines = PropBag.ReadProperty("MaximumLines", kDefaultMaximumLines)
  BkgdColor = PropBag.ReadProperty("BkgdColor", kDefaultBkgdColor)
  Message = PropBag.ReadProperty("Message", kDefaultMessage)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Animate", Animate, kDefaultAnimate
  PropBag.WriteProperty "MaximumLines", MaximumLines, kDefaultMaximumLines
  PropBag.WriteProperty "BkgdColor", BkgdColor, kDefaultBkgdColor
  PropBag.WriteProperty "Message", Message, kDefaultMessage
End Sub

'CSEH: ErrMsgBox
Private Sub UserControl_Resize()
  '<EhHeader>
  On Error GoTo UserControl_Resize_Err
  '</EhHeader>
  If (bResize) Then Exit Sub
  Dim lLineCount As Long

  shpBkgd.Width = Width
  shpBkgd.Height = Height
  txtMsg.Width = Width - 300
  txtMsg.Height = Height - 50
  txtMsg.Left = shpBkgd.Left + 250
  txtMsg.Top = shpBkgd.Top + 25
  lLineCount = SendMessage(txtMsg.hwnd, EM_GETLINECOUNT, 0&, ByVal 0&)
  If (lLineCount <> miNumLines) Then
    RefreshSize
  End If
  
  '<EhFooter>
  Exit Sub
UserControl_Resize_Err:
  Select Case Err.Number
    Case Else
      ' removed
  End Select
  '</EhFooter>
End Sub
Private Sub LongtoRGB(lClr As Long, ByRef r As Integer, g As Integer, b As Integer)

  r = lClr And &HFF&
  g = (lClr And &HFF00&) \ &H100
  b = (lClr And &HFF0000) \ &H10000
End Sub
Private Function HSBtoRGB(ByVal h As Double, ByVal s As Double, ByVal b As Double) As Long
  '<EhHeader>
  On Error GoTo HSBtoRGB_Err
  '</EhHeader>
  Dim i As Integer
  Dim F As Double
  Dim p As Double
  Dim q As Double
  Dim T As Double
  Dim r, g, bl As Double
  Dim RGBColor As Long
  
  If (h < 0 Or h > 360) Then
    Err.Raise eh.AppArgumentNullError, "", "The hue parameter must be in range, 0-360. '" & CStr(h) & "' was passed in."
  End If
  If (s < 0 Or s > 1) Then
    Err.Raise eh.AppArgumentNullError, "", "The saturation parameter must be in range, 0-1. '" & CStr(s) & "' was passed in."
  End If
  If (b < 0 Or b > 1) Then
    Err.Raise eh.AppArgumentNullError, "", "The brightness parameter must be in range, 0-1. '" & CStr(b) & "' was passed in."
  End If
  
  If (s = 0) Then
    ' achromatic (grey)
    RGBColor = RGB(b, b, b)
    Exit Function
  End If

  h = h / 60#        ' sector 0 to 5
'  i = floor( h );
  i = h
  F = h - i      ' factorial part of h
  p = b * (1 - s)
  q = b * (1 - s * F)
  T = b * (1 - s * (1 - F))

  ' Do a couple different things depending on what quadran
  ' the hue is in
  Select Case (i)
    Case 0
      RGBColor = RGB(b, T, p)
    Case 1
      r = q
      g = b
      bl = p
    Case 2
      r = p
      g = b
      bl = T
    Case 3:
      r = p
      g = q
      bl = b
    Case 4:
      r = T
      g = p
      bl = b
    Case Else
      r = b
      g = p
      b = q
  End Select
  HSBtoRGB = RGB(CInt(r * 255), CInt(g * 255), CInt(bl * 255))

  '<EhFooter>
  Exit Function

HSBtoRGB_Err:
  Select Case Err.Number

     Case Else
       Err.Raise Err.Number, Err.Source & " ctlInfoBar:HSBtoRGB", Err.Description
  End Select
  '</EhFooter>
End Function
Private Function MaxDoubles(values() As Double) As Double
  Const smallest As Double = -1.79769313486231E+308
  Dim val As Variant
  MaxDoubles = smallest
  For Each val In values
    If val > MaxDoubles Then
      MaxDoubles = val
    End If
  Next val
End Function

Private Function MinDoubles(values() As Double) As Double
  Const largest As Double = 1.79769313486231E+308
  Dim val As Variant
  Dim i As Long
  MinDoubles = largest
  For i = 0 To UBound(values)
    If CDbl(values(i)) < MinDoubles Then
      MinDoubles = values(i)
    End If
  Next
End Function
Private Sub RGBtoHSB(RGBValue As Long, h As Double, s As Double, b As Double)
  Dim min, max, delta As Variant
  Dim aRGB(2) As Double
  Dim r As Integer
  Dim g As Integer
  Dim bl As Integer
  
  LongtoRGB RGBValue, r, g, bl
  aRGB(0) = r
  aRGB(1) = g
  aRGB(2) = bl
  min = CDbl(MinDoubles(aRGB))
  max = CDbl(MaxDoubles(aRGB))
  b = max / 255

  delta = max - min

  'Left off here converting
  If (max <> 0) Then
    s = delta / max
  Else
    s = 0
    h = -1
    Exit Sub
  End If

  If (r = max) Then
    h = (g - bl) / delta      ' between yellow & magenta
  ElseIf (g = max) Then
    h = 2 + (bl - r) / delta  ' between cyan & yellow
  Else
    h = 4 + (r - g) / delta   ' between magenta & cyan
  End If
    h = h * 60               ' degrees
  If (h < 0) Then
    h = h + 360
  End If
End Sub
